#pragma once
#ifndef APPLICATION_H_
#define APPLICATION_H_

#include "engine.h"
#include "contentmanager.h"
#include "graphicsmanager.h"
#include "inputmanager.h"
#include "audiomanager.h"

namespace EPOC
{
	class TextureSDL;

	class Application : public Engine
	{
	public:
		Application();
		virtual ~Application();

		virtual void Cleanup();
		virtual bool Initialize();
		virtual bool Update(float fTimeDelta);
		virtual void Render(TextureSDL* pDestSurface);

		virtual void HandleEvent(SDL_Event *pEvent);

		inline class ContentManager* GetContentManager()	{ return m_pContentManager;}
		inline class GraphicsManager* GetGraphicsManager()	{ return m_pGraphicsManager;}
		inline class AudioManager* GetAudioManager()		{ return m_pAudioManager;}
		inline class InputManager* GetInputManager()		{ return m_pInputManager;}

	protected:
		virtual bool CreateContentManager();
		virtual bool CreateGraphicsManager();
		virtual bool CreateAudioManager();
		virtual bool CreateInputManager();

	protected:
		ContentManager *m_pContentManager;
		GraphicsManager *m_pGraphicsManager;
		AudioManager *m_pAudioManager;
		InputManager *m_pInputManager;
	};
}; // namespace EPOC

#endif