#include "contentmanager.h"
#include "application.h"

using std::list;
using namespace EPOC;

ContentManager::ContentManager(Application *pApplication)
{
	m_pApplication = pApplication;
	SetClassID(kCLASSID_CONTENTMANAGER);
}

ContentManager::~ContentManager()
{
	ContentManager::Cleanup();
}

void ContentManager::Cleanup()
{
	for(list<BaseObject*>::iterator it = m_rUpdateContainer.begin(); it != m_rUpdateContainer.end(); it++)
	{
		delete (*it);
	}
	m_rUpdateContainer.clear();
}

bool ContentManager::Initialize()
{
	
	return true;
}

 
bool ContentManager::Update( float fTimeDelta)
{
	for(list<BaseObject*>::iterator it = m_rUpdateContainer.begin(); it != m_rUpdateContainer.end();)
	{
		if((*it)->Update(fTimeDelta) == false)
			it = m_rUpdateContainer.erase(it);
		else
			it++;
	}

	return true;
}

void ContentManager::AddUpdateObject(BaseObject* pObject)
{
	if(pObject)
		m_rUpdateContainer.push_back(pObject);
}

void ContentManager::RemoveUpdateObject(BaseObject *pObject)
{
	if(!m_rUpdateContainer.empty())
		m_rUpdateContainer.remove(pObject);
}