#include "texturesdl.h"
#include "textureogl.h"

using std::string;
using namespace EPOC;

TextureSDL::TextureSDL()
{
	SetClassID(kCLASSID_TEXTURE_SDL);
	m_pSDLSurface = NULL;
}

TextureSDL::TextureSDL(GraphicsManager *pGraphicsManager) : Texture(pGraphicsManager)
{
	SetClassID(kCLASSID_TEXTURE_SDL);
	m_pSDLSurface = NULL;
}

TextureSDL::~TextureSDL()
{
	TextureSDL::Cleanup();
}

void TextureSDL::Cleanup()
{
}

bool TextureSDL::Initialize(string sName, string sFilePath, SDL_Surface *pSDLSurface, bool bExclusive)
{
	if(pSDLSurface)
	{
		m_pSDLSurface = pSDLSurface;
		SetDimension(m_pSDLSurface->h, m_pSDLSurface->w);
	}

	return Texture::Initialize(sName, sFilePath, bExclusive);
}
